; 
    include \masm32\include\masm32rt.inc
; 
    .data
    .code
; 
start:
; 
    ASSUME FS:nothing
    xor ebx, ebx

    print "FS:[4]  ",9          ; top of stack
    mov esi, fs:[ebx+4]
    print uhex$(esi),13,10

    print "FS:[8]  ",9          ; bottom of stack
    mov edi, fs:[ebx+8]
    print uhex$(edi),13,10
    
    mov ebx, fs:[ebx+18h]       ; linear address of TIB
    print "ADDR TIB",9
    print uhex$(ebx),13,10
    
    print "[TIB+4] ",9          ; top of stack
    print uhex$([ebx+4]),13,10

    print "[TIB+8] ",9          ; bottom of stack
    print uhex$([ebx+8]),13,10

    print "ESP     ",9
    print uhex$(esp),13,10

    print "[TOS]   ",9
    mov eax, [esi]
    print uhex$(eax),13,10
    mov ebx, -4
    REPEAT 16
      print "[TOS"
      print str$(ebx),"] ",9
      mov eax, [esi+ebx]
      print uhex$(eax),13,10
      sub ebx, 4
    ENDM    

    inkey "Press any key to exit..."
    exit
; 
end start
